#ifndef _PCIE9602_DEVICE_
#define _PCIE9602_DEVICE_
//#################### ADӲPCIE9602_PARA_AD #####################
// ADʵӲ
typedef struct _PCIE9602_PARA_AD     
{
	LONG ADMode;            // ADģʽѡ(/鷽ʽ)
	LONG FirstChannel;      // ͨ[0,31]
	LONG LastChannel;       // ĩͨ[0,31],Ҫĩͨڻͨ
	LONG Frequency;         // ɼƵ,λΪHz
	LONG InputRange;		// ģ̷Χ
	LONG GroupInterval;     // ʱ(λ΢)[1, 419430]
	LONG LoopsOfGroup;	    // ѭ[1, 65535]
	LONG Gains;				// 
	LONG TriggerMode;       // ģʽѡ
	LONG TriggerSource;		// Դѡ
	LONG TriggerType;		// ѡ(ش/ƽ)
	LONG TriggerDir;		// ѡ(/򴥷)
	LONG ClockSource;		// ʱԴѡ(/ʱԴ)
	LONG bClockOutput;      // ʱCLKOUT,=TRUE:ʱ, =FALSE:ֹʱ
	LONG GroundingMode;		// ӵطʽ˻˫ѡ
} PCIE9602_PARA_AD, *PPCIE9602_PARA_AD;

// ADӲPCIE9602_PARA_ADеADModeʹùģʽѡ
const long PCIE9602_ADMODE_SEQUENCE			= 0x00; // 
const long PCIE9602_ADMODE_GROUP			= 0x01; // 

//***********************************************************
// ADӲPCIE9602_PARA_ADеInputRangeģ뷶Χʹõѡ
const long PCIE9602_INPUT_N10000_P10000mV	= 0x00; // 10000mV
const long PCIE9602_INPUT_N5000_P5000mV		= 0x01; // 5000mV
const long PCIE9602_INPUT_N2500_P2500mV		= 0x02; // 2500mV
const long PCIE9602_INPUT_0_P10000mV		= 0x03; // 010000mV
const long PCIE9602_INPUT_0_P5000mV			= 0x04; // 05000mV

//***********************************************************
// ADPCIE9602_PARA_ADеGainsʹõӲѡ
const long PCIE9602_GAINS_1MULT				= 0x00; // 1
const long PCIE9602_GAINS_2MULT				= 0x01; // 2
const long PCIE9602_GAINS_5MULT				= 0x02; // 4
const long PCIE9602_GAINS_10MULT			= 0x03; // 8

//***********************************************************
// ADӲPCIE9602_PARA_ADеTriggerModeԱʹôģʽѡ
const long PCIE9602_TRIGMODE_SOFT			= 0x00; // (ڴ)
const long PCIE9602_TRIGMODE_POST			= 0x01; // Ӳ󴥷(ⴥ)

//***********************************************************
// ADӲPCIE9602_PARA_ADеTriggerSourceԱʹôģʽѡ
const long PCIE9602_TRIGSRC_ATR				= 0x00; // ATR
const long PCIE9602_TRIGSRC_DTR				= 0x01; // DTR

// ADӲPCIE9602_PARA_ADеTriggerTypeʹõѡ
const long PCIE9602_TRIGTYPE_EDGE			= 0x00; // ش
const long PCIE9602_TRIGTYPE_PULSE			= 0x01; // ƽ

//***********************************************************
// ADӲPCIE9602_PARA_ADеTriggerDirʹõѡ
const long PCIE9602_TRIGDIR_NEGATIVE		= 0x00; // 򴥷(͵ƽ/½ش)
const long PCIE9602_TRIGDIR_POSITIVE		= 0x01; // 򴥷(ߵƽ/ش)
const long PCIE9602_TRIGDIR_POSIT_NEGAT		= 0x02; // 򴥷(/͵ƽ/½ش)

//***********************************************************
// ADӲPCIE9602_PARA_ADеClockSourceʱԴʹõѡ
const long PCIE9602_CLOCKSRC_IN				= 0x00; // ڲʱ
const long PCIE9602_CLOCKSRC_OUT			= 0x01; // ⲿʱ

// ADӲPCIE9602_PARA_ADеbClockOutputԱʹڲⲿʱԴѡ
const long PCIE9602_CLOCKOUT_DISABLE		= 0x00; // ֹϵԴʱ
const long PCIE9602_CLOCKOUT_ENABLE			= 0x01; // ϵԴʱ

//***********************************************************
// ADӲPCIE9602_PARA_ADеGroundingModeʹõģźŽӵطʽѡ
const long PCIE9602_GNDMODE_SE				= 0x00;	// ˷ʽ(SE:Single end)
const long PCIE9602_GNDMODE_DI				= 0x01;	// ˫˷ʽ(DI:Differential)

//*************************************************************************************
// ADʵӲ
typedef struct _PCIE9602_STATUS_AD     
{
	LONG bNotEmpty;			// FIFO洢ķǿձ־=TRUEǿգ = FALSE 
	LONG bHalf;				// FIFO洢İ־=TRUEϣ = FALSE 
	LONG bOverflow;			// FIFO洢־= TRUEѷ = FALSEδ
} PCIE9602_STATUS_AD, *PPCIE9602_STATUS_AD;

const int MAX_SEGMENT_COUNT = 64;
typedef struct _PCIE9602_STATUS_DMA     
{
	LONG iCurSegmentID;								// ǰλID,ʾDMAڴĻ
	LONG bSegmentSts[MAX_SEGMENT_COUNT];			// ¾״̬,=1ʾӦΪ,Ϊ
	LONG bBufferOverflow;							// ״̬
} PCIE9602_STATUS_DMA, *PPCIE9602_STATUS_DMA;

//***********************************************************
// DAWriteDeviceDAģΧOutputRangeʹõѡ
const long PCIE9602_OUTPUT_0_P5000mV			= 0x00;		// 05000mV
const long PCIE9602_OUTPUT_0_P10000mV			= 0x01;		// 010000mV
const long PCIE9602_OUTPUT_0_P10800mV			= 0x02;		// 010800mV
const long PCIE9602_OUTPUT_N5000_P5000mV		= 0x03;		// 5000mV
const long PCIE9602_OUTPUT_N10000_P10000mV		= 0x04;		// 10000mV
const long PCIE9602_OUTPUT_N10800_P10800mV		= 0x05;		// 10800mV

//***********************************************************
// ڼCNTĲ
// ӲControlModeģʽѡ
const long PCIE9602_GATEMODE_POSITIVE_0	= 0x00;		// COUNTER:GATEߵƽʱ͵ƽʱֹͣʱдֵֵ
													// жϣдֵʼʱOUTʼΪ00ʱOUTΪ1

const long PCIE9602_GATEMODE_RISING_1	= 0x01;		// COUNTER:GATEϱشгGATEװֵ
													// ɱ̵壺дֵʱOUTΪ1ʼʱOUTΪ00ʱOUTٴΪ1

const long PCIE9602_GATEMODE_POSITIVE_2	= 0x02;		// COUNTER:GATEߵƽʱ͵ƽʱֹͣʱдֵֵ
													// ƵʷڼOUTΪ10һڵ0װֵ

const long PCIE9602_GATEMODE_POSITIVE_3	= 0x03;		// COUNTER:GATEߵƽʱ͵ƽʱֹͣʱдֵֵ
													// ڼOUTΪ10һڵ0װֵ

const long PCIE9602_GATEMODE_POSITIVE_4	= 0x04;		// COUNTER:GATEߵƽʱ͵ƽʱֹͣʱдֵֵ
													// ѡͨдֵOUTΪ1 OUTһڵ͵ƽź

const long PCIE9602_GATEMODE_RISING_5	= 0x05;		// COUNTER:GATEϱشгGATEװֵ
													// ӲѡͨдֵOUTΪ1 OUTһڵ͵ƽź

//***********************************************************
// ûӿ
#ifndef _PCIE9602_DRIVER_
#define DEVAPI __declspec(dllimport)
#else
#define DEVAPI __declspec(dllexport)
#endif

#ifdef __cplusplus
extern "C" {
#endif
	//######################## 豸 ##############################
	HANDLE DEVAPI FAR PASCAL PCIE9602_CreateDevice(int DeviceLgcID = 0);     // ߼Ŵ豸
	int DEVAPI FAR PASCAL PCIE9602_GetDeviceCount(HANDLE hDevice); // ȡ豸̨
	BOOL DEVAPI FAR PASCAL PCIE9602_ListDeviceDlg(HANDLE hDevice); // ԶԻ巽ʽбϵͳееĸPCI豸
	BOOL DEVAPI FAR PASCAL PCIE9602_ReleaseDevice(HANDLE hDevice); // ͷ豸

	//####################### ADݶȡ #################################
	// ڴͨûЩӿ򵥡ݡɿû֪豸
	// Ͳ㸴ӵӲЭͷƱ̣ĳʼ豸Ͷȡ
	// ADɸЧʵָ١ݲɼ
	BOOL DEVAPI FAR PASCAL PCIE9602_ADCalibration(				// 豸У׼.		
										HANDLE hDevice);		// 豸

	// ADѯʽ
	BOOL DEVAPI FAR PASCAL PCIE9602_InitDeviceProAD(			// ʼ豸TRUE,豸׼.
										HANDLE hDevice,			// 豸,CreateDevice
										PPCIE9602_PARA_AD pADPara); // Ӳ, ڴ˺оӲ״̬

	BOOL DEVAPI FAR PASCAL PCIE9602_StartDeviceProAD(			// ڳʼ֮豸
										HANDLE hDevice);		// 豸,CreateDevice

	BOOL DEVAPI FAR PASCAL PCIE9602_ReadDeviceProAD_Npt(		// AD־Чʱô˺ȡ豸ϵAD(ǿշʽ)
										HANDLE hDevice,			// 豸,CreateDevice
										LONG ADBuffer[],		// ԭʼADݵû
										LONG nReadSizeWords,	// ƫƵݳ()
										PLONG nRetSizeWords);   // ʵʶȡĳ()

	BOOL DEVAPI FAR PASCAL PCIE9602_GetDevStatusProAD(			// ADȡ豸ĸ״̬,ֵʾǷɹ
										HANDLE hDevice,			// 豸,CreateDevice
										PPCIE9602_STATUS_AD pADStatus); // ADĸϢṹ

	BOOL DEVAPI FAR PASCAL PCIE9602_ReadDeviceProAD_Half(		// AD־Чʱô˺ȡ豸ϵAD(ʽ)
										HANDLE hDevice,			// 豸,CreateDevice
										LONG ADBuffer[],		// ԭʼADݵû
										LONG nReadSizeWords,	// ƫλݳ()
										PLONG nRetSizeWords);	// ʵʶȡĳ()
		
    BOOL DEVAPI FAR PASCAL PCIE9602_StopDeviceProAD(			// 豸֮ͣ豸
										HANDLE hDevice);		// 豸,CreateDevice

	BOOL DEVAPI FAR PASCAL PCIE9602_ReleaseDeviceProAD(			// رAD豸,ֹ,ͷԴ
										HANDLE hDevice);		// 豸,CreateDevice

	//##################### ADݶȡ(DMAʽ)(ϲû) ###########################
	// ADֱڴ(DMA)ʽ
	BOOL DEVAPI FAR PASCAL PCIE9602_InitDeviceDmaAD(			// ʼ豸TRUE,豸׼.
										HANDLE hDevice,			// 豸,CreateDevice
										HANDLE hDmaEvent,		// DMA¼,CreateSystemEvent
										LONG ADBuffer[],		// û,Ϊά
										LONG nReadSizeWords,	// ÿDMAʱ,ûָӦȡʵʳ(ҪСڻnSegmentSizeWords)
										LONG nSegmentCount,		// ֶε,ȡֵΧΪ2-128
										LONG nSegmentSizeWords,	// ֶεĶγ(FIFO)
										PPCIE9602_PARA_AD pADPara);// Ӳ, ڴ˺оӲ״̬

    BOOL DEVAPI FAR PASCAL PCIE9602_StartDeviceDmaAD(			// ڳʼ֮豸
										HANDLE hDevice);		// 豸,CreateDevice

	BOOL DEVAPI FAR PASCAL PCIE9602_GetDevStatusDmaAD(			// ADȡDMAй״̬,ֵʾǷɹ
										HANDLE hDevice,			// 豸,CreateDevice
										PPCIE9602_STATUS_DMA pDMAStatus); // õDMA״̬

	BOOL DEVAPI FAR PASCAL PCIE9602_SetDevStatusDmaAD(			// ADDMAй״̬,ֵʾǷɹ
										HANDLE hDevice,			// 豸,CreateDevice
										LONG iClrBufferID);		// ҪĻID,Ϊ0
		
    BOOL DEVAPI FAR PASCAL PCIE9602_StopDeviceDmaAD(			// 豸֮ͣ豸
										HANDLE hDevice);		// 豸,CreateDevice

	BOOL DEVAPI FAR PASCAL PCIE9602_ReleaseDeviceDmaAD(			// رAD豸,ֹ,ͷԴ
										HANDLE hDevice);		// 豸,CreateDevice
	
	//##################### ADӲ ###########################
	BOOL DEVAPI FAR PASCAL PCIE9602_SaveParaAD(HANDLE hDevice, PPCIE9602_PARA_AD pADPara); // ǰADϵͳ
    BOOL DEVAPI FAR PASCAL PCIE9602_LoadParaAD(HANDLE hDevice, PPCIE9602_PARA_AD pADPara); // ADϵͳж
    BOOL DEVAPI FAR PASCAL PCIE9602_ResetParaAD(HANDLE hDevice, PPCIE9602_PARA_AD pADPara); // ADָĬֵ

	//####################### DAݶȡ #################################
	// ڴͨûЩӿ򵥡ݡɿû֪豸
	// Ͳ㸴ӵӲЭͷƱ̣ĳʼ豸
	// DAɸЧʵָ١Ĳ
	// DAͨú
    BOOL DEVAPI FAR PASCAL PCIE9602_WriteDeviceDA(				// дDA
										HANDLE hDevice,			// 豸,CreateDevice
										LONG OutputRange,		// ̣嶨οĳ岿
										SHORT nDAData,			// DAԭʼ[0, 4095]
										int nDAChannel);		// DAͨ[0-3](д4ĸͨ)
	// DAУ׼
	BOOL DEVAPI FAR PASCAL PCIE9602_StartCalibration(			// DAУ׼
										HANDLE hDevice);		// 豸

	BOOL DEVAPI FAR PASCAL PCIE9602_GetDACalibration(			// 豸DAУ׼		
										HANDLE hDevice,			// 豸
										LONG OutputRange,		// ,ֱͨ
										LONG CalMode,			// 0ΪУ׼1ΪУ׼
										PLONG pCalData,			// У׼ֵ
										int nDAChannel);		// DAͨ,ȡֵΧΪ0-1

	BOOL DEVAPI FAR PASCAL PCIE9602_SetDACalibration(			// 豸DAУ׼		
										HANDLE hDevice,			// 豸
										LONG OutputRange,		// ,ֱͨ
										LONG CalMode,			// 0ΪУ׼1ΪУ׼
										LONG CalData,			// У׼ֵ
										int nDAChannel);		// DAͨ,ȡֵΧΪ0-1

	BOOL DEVAPI FAR PASCAL PCIE9602_StopCalibration(			// ֹͣDAУ׼
										HANDLE hDevice);		// 豸


	//####################### I/O #################################
	// ûʹWriteRegisterULongReadRegisterULongȺֱӿƼĴI/O
	// ʹʡ£ҪļĴλȣֻ
	// VBԵԲô򵥵ʵָͨĿơ
	BOOL DEVAPI FAR PASCAL PCIE9602_GetDeviceDI(				// ȡÿ״̬     
										HANDLE hDevice,			// 豸,CreateDevice								        
										BYTE bDISts[16]);		// ״̬(ע: 붨Ϊ16ֽԪص)

	BOOL DEVAPI FAR PASCAL PCIE9602_SetDeviceDO(				// ״̬
										HANDLE hDevice,			// 豸,CreateDevice        
										BYTE bDOSts[16]);		// ״̬(ע: 붨Ϊ16ֽԪص)

	BOOL DEVAPI FAR PASCAL PCIE9602_RetDeviceDO(				// ״̬
										HANDLE hDevice,			// 豸,CreateDevice        
										BYTE bDOSts[16]);		// ״̬(ע: 붨Ϊ16ֽԪص)

	//##################### ƺ ##########################
	BOOL DEVAPI FAR PASCAL PCIE9602_SetDeviceCNT(				// ʼ
										HANDLE	hDevice,		// 豸
										ULONG	ContrlMode,		// ģʽ
										ULONG	CNTVal);		// ֵ

	BOOL DEVAPI FAR PASCAL PCIE9602_GetDeviceCNT(				// ȡø·ĵǰֵ
										HANDLE	hDevice,		// 豸,CreateDevice
										PULONG	pCNTVal);		// ؼֵ

	//################# ڴӳĴֱӲд ########################
	// ûԱ豸ֱӡ⡢Ͳ㡢ӵĿơ
	// ƶҪĿ̺ͿЧʱûʹЩӿʵ֡
	BOOL DEVAPI FAR PASCAL PCIE9602_GetDeviceBar(				// ȡָָ豸ĴBARַ
										HANDLE hDevice,			// 豸,CreateDevice
										__int64 pbPCIBar[6]);	// PCI BARеַ,PCI BARжٿõַ뿴Ӳ˵

	BOOL DEVAPI FAR PASCAL PCIE9602_WriteRegisterByte(			// ָĴռλд뵥
										HANDLE hDevice,			// 豸,CreateDevice
										__int64 pbLinearAddr,	// ָĴԻַ,GetDeviceAddrеpbLinearAddrֵ
										ULONG OffsetBytes,		// Իַַƫλ(ֽ)
										BYTE Value);			// ַָд뵥ֽݣַԻַƫλþ

	BOOL DEVAPI FAR PASCAL PCIE9602_WriteRegisterWord(			// д˫ֽݣͬϣ
										HANDLE hDevice, 
										__int64 pbLinearAddr, 
										ULONG OffsetBytes,  
										WORD Value);

	BOOL DEVAPI FAR PASCAL PCIE9602_WriteRegisterULong(			// дĽݣͬϣ
										HANDLE hDevice, 
										__int64 pbLinearAddr, 
										ULONG OffsetBytes,  
										ULONG Value);

	BYTE DEVAPI FAR PASCAL PCIE9602_ReadRegisterByte(			// 뵥ֽݣͬϣ
										HANDLE hDevice, 
										__int64 pbLinearAddr, 
										ULONG OffsetBytes);

	WORD DEVAPI FAR PASCAL PCIE9602_ReadRegisterWord(			// ˫ֽݣͬϣ
										HANDLE hDevice, 
										__int64 pbLinearAddr, 
										ULONG OffsetBytes);

	ULONG DEVAPI FAR PASCAL PCIE9602_ReadRegisterULong(			// ֽݣͬϣ
										HANDLE hDevice, 
										__int64 pbLinearAddr, 
										ULONG OffsetBytes);

	//################# I/O˿ֱӲд ########################
	// ûԱ豸ֱӡ⡢Ͳ㡢ӵĿơ
	// ƶҪĿ̺ͿЧʱûʹЩӿʵ֡
	// ЩҪڴͳ豸ISAߡڡڵ豸ڱPCI豸
    BOOL DEVAPI FAR PASCAL PCIE9602_WritePortByte(				// 8λд˿
										HANDLE hDevice,			// 豸(CreateDevice)
										__int64 pPort,				// ˿ڵַ
										BYTE Value);			// д8λ

    BOOL DEVAPI FAR PASCAL PCIE9602_WritePortWord(HANDLE hDevice, __int64 pPort, WORD Value);
    BOOL DEVAPI FAR PASCAL PCIE9602_WritePortULong(HANDLE hDevice, __int64 pPort, ULONG Value);

    BYTE DEVAPI FAR PASCAL PCIE9602_ReadPortByte(HANDLE hDevice, __int64 pPort);
    WORD DEVAPI FAR PASCAL PCIE9602_ReadPortWord(HANDLE hDevice, __int64 pPort);
    ULONG DEVAPI FAR PASCAL PCIE9602_ReadPortULong(HANDLE hDevice, __int64 pPort);
	// Ҫûģʽ£ֱӷӲ˿ڣ밲װʹISA\CommUserµReadPortByteExȺ

	//########################### Ӳ ######################################
	HANDLE DEVAPI FAR PASCAL PCIE9602_CreateSystemEvent(void); // ں¼󣬹InitDeviceDmaADVB̵߳Ⱥʹ
	BOOL DEVAPI FAR PASCAL PCIE9602_ReleaseSystemEvent(HANDLE hEvent); // ͷں¼

#ifdef __cplusplus
}
#endif

//***********************************************************
// FIFO洢ĳ()
const long FIFO_IDT7202_LENGTH			= 1024;
const long FIFO_IDT7203_LENGTH			= 2048;
const long FIFO_IDT7204_LENGTH			= 4096;
const long FIFO_IDT7205_LENGTH			= 8192;
const long FIFO_IDT7206_LENGTH			= 16384;
const long FIFO_IDT7207_LENGTH			= 32768;

// Զ
#ifndef _PCIE9602_DRIVER_
	#ifndef _WIN64
		#pragma comment(lib, "PCIE9602_32.lib")
		#pragma message("======== Welcome to use our art company's products!")
		#pragma message("======== Automatically linking with PCIE9602_32.dll...")
		#pragma message("======== Successfully linked with PCIE9602_32.dll")
	#else
		#pragma comment(lib, "PCIE9602_64.lib")
		#pragma message("======== Welcome to use our art company's products!")
		#pragma message("======== Automatically linking with PCIE9602_64.dll...")
		#pragma message("======== Successfully linked with PCIE9602_64.dll")
	#endif
#endif

#endif // _PCIE9602_DEVICE_